[Aspose.3D Cloud SDK for Python](https://products.aspose.cloud/3d/python) empowers your Python applications to connect with 3D document formats. The APIs let engineers read, convert, build, alter and control the substance of the [3D document formats](https://docs.aspose.cloud/display/3dcloud/Supported+Document+Formats) without any 3D modeling and rendering software installed on the machine..

## 3D Features

- Create 3D entities (Box, Sphere, Plane, Torus, Cylinder).
- Perform processing of 3D models and attributes.
- Perform transformation, translation, rotation & scaling of 3D objects.
- Conversion of 3D files to another format.
- Convert whole of the 3D file or convert a specific part only.
- Extract 3D scenes and export to various formats.
- Perform parametric modeling, 3D modeling & data processing.
- Create cloud-based folder structure & perform cloud-based conversion of 3D files.
- Extract raw data or 3D content from a password-protected 3D PDF file.
- Supports working with triangulate meshes, triangulate whole or part of the 3D scene.
- Address nodes by object addressing path or remove nodes with attached light or camera.
- Remove 3D objects from a scene.

## Enhancements in Version 20.5

- Support convert more file formats(HTML/VRML...).
- Triangulate part of the scene(Specified by OAP) and save the scene to different file 

## Read & Write 3D Formats

FBX, STL, OBJ, 3DS, U3D, DAE, GLTF, DRC, RVM, PDF, AMF, PLY

## Read 3D Formats

X, JT, DXF, 3MF, ASE, VRML 

## Write 3D Formats

HTML

## Getting Started with Aspose.3D Cloud SDK for Python

Firstly, create an account at [Aspose for Cloud](https://dashboard.aspose.cloud/#/apps) to get your application information and free quota to use the API. Now execute `pip install aspose3dcloud` from the command line to fetch the SDK. The complete source code is available at [GitHub Repository](https://github.com/aspose-3d-cloud/aspose-3d-cloud-python).

[Product Page](https://products.aspose.cloud/3d/python) | [Documentation](https://docs.aspose.cloud/display/3dcloud/Home) | [Demo](https://products.aspose.cloud/3d/family) | [API Reference](https://apireference.aspose.cloud/3d/) | [Examples](https://github.com/aspose-3d-cloud/aspose-3d-cloud-python) | [Blog](https://blog.aspose.cloud/category/3d/) | [Free Support](https://forum.aspose.cloud/c/3d) | [Free Trial](https://dashboard.aspose.cloud/#/apps)